#include "qreflection.h"
#include <QDebug>
#include <QMetaObject>
#include <QMetaMethod>
#include <QStringList>

QReflection::QReflection(QObject *parent) :
    QObject(parent)
{
}

void QReflection::callMethod(QString name, QStringList args)
{
    //поиск метода по сигнатуре
    int index = metaObject()->indexOfMethod(name.toLatin1());

    //если метод с сигнатурой name не найден
    if (index < 0){
        qDebug() << "method " + name + " not found";
        return;
    }
    //Вызываем метод по индексу. Параметры должны указываться через макрос Q_ARG или Q_RETURN_ARG (для методов, возвращающих значения)
    metaObject()->method(index).invoke(this, Q_ARG(QString, args.at(0)), Q_ARG(QString, args.at(1)), Q_ARG(QString, args.at(2)));
}

QStringList QReflection::methodList()
{
    QStringList list;

    //Цикл по методам класса и запись их сигнатур в список list
    for (int i = metaObject()->methodOffset(); i < metaObject()->methodCount(); i++){
        list.append(metaObject()->method(i).methodSignature());
    }
    return list;
}

void QReflection::method1()
{
    qDebug() << "method1!";
}

void QReflection::method2()
{
    qDebug() << "method2!";
}

void QReflection::upperCase(QString value)
{
    qDebug() << value.toUpper();
}
